- README

- Top Level Namespace
- Adler32
- ArgumentError
- Array
- Atomic
- Base64
  - Error
- Benchmark
  - BM
    - Job
    - Tms
  - IPS
    - Entry
    - Job
- BigFloat
- BigInt
- BigRational
- BitArray
- Bool
- Box
- Bytes
- Channel
  - Buffered
  - ClosedError
  - ReceiveAction
  - SelectAction
  - SendAction
  - Unbuffered
- Char
  - Reader
- Class
- Colorize
  - Object
  - ObjectExtensions
- Comparable
- Complex
- Concurrent
  - CanceledError
- CRC32
- Crypto
  - Bcrypt
    - Error
    - Password
  - Blowfish
  - Subtle
- CSV
  - Builder
    - Row
  - Error
  - Lexer
  - MalformedCSVError
  - Parser
  - Row
  - Token
    - Kind
- Debug
  - DWARF
    - Abbrev
      - Attribute
    - AT
    - FORM
    - Info
      - Value
    - LineNumbers
      - Register
      - Row
      - Sequence
    - LNE
    - LNS
    - Strings
    - TAG
  - ELF
    - Endianness
    - Error
    - Ident
    - Klass
    - Machine
    - OSABI
    - SectionHeader
      - Flags
      - Type
    - Type
- Deque
- Digest
  - Base
  - MD5
  - SHA1
- Dir
- DivisionByZero
- DL
- ECR
- Enum
- Enumerable
  - EmptyError
- ENV
- Errno
- Exception
- Fiber
- File
  - Stat
- FileUtils
- Flate
  - Error
  - Reader
  - Strategy
  - Writer
- Float
  - Primitive
- Float32
- Float64
- GC
  - Stats
- Gzip
  - Error
  - Header
  - Reader
  - Writer
- Hash
- HTML
- HTTP
  - Client
    - BodyType
    - Response
  - CompressHandler
  - ComputedContentTypeHeader
  - Cookie
  - Cookies
  - ErrorHandler
  - FormData
    - Builder
    - Error
    - FileMetadata
    - Parser
    - Part
  - Handler
    - Proc
  - Headers
  - LogHandler
  - Multipart
    - Builder
    - Error
    - Parser
  - Params
    - Builder
  - Request
  - Server
    - Context
    - RequestProcessor
    - Response
  - StaticFileHandler
    - DirectoryListing
  - WebSocket
  - WebSocketHandler
- Indexable
- IndexError
- INI
- Int
  - Primitive
  - Signed
  - Unsigned
- Int16
- Int32
- Int64
- Int8
- InvalidByteSequenceError
- IO
  - Buffered
  - ByteFormat
    - BigEndian
    - LittleEndian
    - NetworkEndian
    - SystemEndian
  - Delimited
  - EncodingOptions
  - EOFError
  - Error
  - FileDescriptor
  - Hexdump
  - Memory
  - MultiWriter
  - Seek
  - Sized
  - Timeout
- IPSocket
- Iterable
- Iterator
  - IteratorWrapper
  - Stop
- JSON
  - Any
  - Builder
    - ArrayState
    - DocumentEndState
    - DocumentStartState
    - ObjectState
    - StartState
    - State
  - Error
  - Lexer
  - ParseException
  - Parser
  - PullParser
  - Token
  - Type
- KeyError
- Levenshtein
  - Finder
- LLVM
  - ABI
    - AArch64
    - ArgKind
    - ArgType
    - ARM
    - FunctionType
    - X86
    - X86_64
      - RegClass
  - AtomicOrdering
  - AtomicRMWBinOp
  - Attribute
  - AttributeIndex
  - BasicBlock
  - BasicBlockCollection
  - Builder
  - CallConvention
  - CodeGenFileType
  - CodeGenOptLevel
  - CodeModel
  - Context
  - DIBuilder
  - DIFlags
  - DwarfTag
  - DwarfTypeEncoding
  - Function
  - FunctionCollection
  - FunctionPassManager
    - Runner
  - GenericValue
  - GlobalCollection
  - InstructionCollection
  - IntPredicate
  - JITCompiler
  - Linkage
  - MemoryBuffer
  - Module
  - ModuleFlag
  - ModulePassManager
  - ParameterCollection
  - PassManagerBuilder
  - PassRegistry
  - PhiTable
  - RealPredicate
  - RelocMode
  - Target
  - TargetData
  - TargetMachine
  - Type
    - Kind
  - Value
    - Kind
  - ValueMethods
  - VerifierFailureAction
- Logger
  - Formatter
  - Severity
- Markdown
  - HTMLRenderer
  - Parser
    - PrefixHeader
    - UnorderedList
  - Renderer
- Math
- Mutex
- NamedTuple
- Nil
- Number
  - Primitive
- OAuth
  - AccessToken
  - Consumer
  - Error
  - RequestToken
- OAuth2
  - AccessToken
    - Bearer
    - Mac
  - Client
  - Error
  - Session
- Object
- OpenSSL
  - Digest
    - Error
    - UnsupportedError
  - DigestBase
  - Error
  - HMAC
  - MD5
  - SHA1
  - SSL
    - Context
      - Client
      - Server
    - Error
    - ErrorType
    - Modes
    - Options
    - Socket
      - Client
      - Server
    - VerifyMode
    - X509VerifyFlags
- OptionParser
  - Exception
  - InvalidOption
  - MissingOption
- PartialComparable
- Pointer
  - Appender
- PrettyPrint
- Proc
- Process
  - Env
  - Status
  - Stdio
  - Tms
- Random
  - MT19937
- Range
- Readline
  - CompletionProc
  - KeyBindingProc
- Reference
- Reflect
- Regex
  - MatchData
  - Options
- SecureRandom
- Set
- Signal
- Slice
- Socket
  - Address
  - Addrinfo
  - Error
  - Family
  - IPAddress
  - Protocol
  - Server
  - Type
  - UNIXAddress
- Spec
  - Expectations
  - Methods
  - ObjectExtensions
- StaticArray
- String
  - Builder
  - RawConverter
- StringPool
- StringScanner
- Struct
- Symbol
- System
- TCPServer
- TCPSocket
- Tempfile
- Termios
  - AttributeSelection
  - BaudRate
  - ControlMode
  - InputMode
  - LineControl
  - LocalMode
  - OutputMode
- Time
  - DayOfWeek
  - EpochConverter
  - EpochMillisConverter
  - Format
    - Error
  - Kind
  - MonthSpan
  - Span
- Tuple
- TypeCastError
- UDPSocket
- UInt16
- UInt32
- UInt64
- UInt8
- Unicode
  - CaseOptions
- Union
- UNIXServer
- UNIXSocket
- URI
  - Error
- Value
- WeakRef
- XML
  - Attributes
  - AttributeType
  - Builder
  - Error
  - HTMLParserOptions
  - Namespace
  - Node
  - NodeSet
  - ParserOptions
  - Reader
  - SaveOptions
  - Type
  - XPathContext
- YAML
  - Any
  - Builder
  - Error
  - EventKind
  - ParseException
  - Parser
  - PullParser
  - Type
- Zip
  - CompressionMethod
  - Error
  - File
    - Entry
  - FileInfo
  - Reader
    - Entry
  - Writer
    - Entry
- Zlib
  - Error
  - Reader
  - Writer

# struct BigInt

- BigInt
- Int
- Number
- Value
- Object

## Overview

A `BigInt` can represent arbitrarily large integers.

It is implemented under the hood with GMP.

## Included Modules

- Comparable(Float)
- Comparable(BigInt)
- Comparable(UInt16 | UInt32 | UInt64 | UInt8)
- Comparable(Int16 | Int32 | Int64 | Int8)

## Defined in:

## Class Method Summary

- .new(str : String, base = 10)

  Creates a `BigInt` with the value denoted by str in the given base.

- .new(num : Int::Signed)

  Creates a `BigInt` from the given num.

- .new(num : Int::Unsigned)

  Creates a `BigInt` from the given num.

- .new(num : Float)

  Creates a `BigInt` from the given num.

- .new(num : BigInt)

  Returns num.

- .new

  Creates a `BigInt` with the value zero.

## Instance Method Summary

- #%(other : Int) : BigInt
- #&(other : Int) : BigInt
- #*(other : BigInt) : BigInt
- #*(other : Int::Signed) : BigInt
- #*(other : Int::Unsigned) : BigInt
- #**(other : Int) : BigInt
- #+(other : BigInt) : BigInt
- #+(other : Int) : BigInt
- #-(other : BigInt) : BigInt
- #-(other : Int) : BigInt
- #- : BigInt
- #/(other : Int) : BigInt
- #<<(other : Int) : BigInt
- #<=>(other : BigInt)
- #<=>(other : Int::Signed)
- #<=>(other : Int::Unsigned)
- #<=>(other : Float)
- #>>(other : Int) : BigInt
- #^(other : Int) : BigInt
- #abs : BigInt
- #clone
- #digits : Array(Int32)
- #gcd(other : BigInt) : BigInt
- #gcd(other : Int) : Int
- #hash
- #inspect
- #inspect(io)
- #lcm(other : BigInt) : BigInt
- #lcm(other : Int) : BigInt
- #popcount
- #remainder(other : Int) : BigInt
- #tdiv(other : Int) : BigInt
- #to_big_i
- #to_f
- #to_f32
- #to_f64
- #to_i
- #to_i16
- #to_i32
- #to_i64
- #to_i8
- #to_s(base : Int)

  Returns a string containing the representation of big radix base (2 through 36).

- #to_s

  Returns a string representation of self.

- #to_s(io)

  Returns a string representation of self.

- #to_u
- #to_u16
- #to_u32
- #to_u64
- #to_u8
- #to_unsafe
- #unsafe_floored_div(other : Int) : BigInt
- #unsafe_floored_div(other : BigInt) : BigInt
- #unsafe_floored_mod(other : BigInt) : BigInt
- #unsafe_floored_mod(other : Int) : BigInt
- #unsafe_truncated_div(other : BigInt) : BigInt
- #unsafe_truncated_div(other : Int) : BigInt
- #unsafe_truncated_mod(other : BigInt) : BigInt
- #unsafe_truncated_mod(other : Int) : BigInt
- #|(other : Int) : BigInt
- #~ : BigInt

### Instance methods inherited from module `Comparable(Float)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigInt)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(UInt16 | UInt32 | UInt64 | UInt8)`

<(other : T | T | T | T) <, <=(other : T | T | T | T) <=, <=>(other : T | T | T | T) <=>, ==(other : T | T | T | T) ==, >(other : T | T | T | T) >, >=(other : T | T | T | T) >=

### Instance methods inherited from module `Comparable(Int16 | Int32 | Int64 | Int8)`

<(other : T | T | T | T) <, <=(other : T | T | T | T) <=, <=>(other : T | T | T | T) <=>, ==(other : T | T | T | T) ==, >(other : T | T | T | T) >, >=(other : T | T | T | T) >=

### Instance methods inherited from struct `Int`

%(other : Int)
%(other : BigInt) : BigInt %, *(other : BigRational)
*(other : BigInt) : BigInt *, **(exponent : Float) : Float64
**(exponent : Int) : self **, +(other : BigRational)
+(other : BigInt) : BigInt +, -(other : BigRational)
-(other : BigInt) : BigInt -, /(other : BigRational)
/(other : Int)
/(other : BigInt) : BigInt /, <<(count : Int) <<, <=>(other : BigInt)
<=>(other : BigRational) <=>, ===(char : Char) ===, >>(count : Int) >>, abs abs, bit(bit) bit, ceil ceil, chr chr, day day, days days, divisible_by?(num) divisible_by?, downto(to)
downto(to, &block : self -> ) : Nil downto, even? even?, fdiv(other) fdiv, floor floor, gcd(other : Int) gcd, gcm(other : BigInt) : Int gcm, hash hash, hour hour, hours hours, lcm(other : Int)
lcm(other : BigInt) : BigInt lcm, millisecond millisecond, milliseconds milliseconds, minute minute, minutes minutes, modulo(other) modulo, month month, months months, odd? odd?, popcount popcount, pred pred, remainder(other : Int) remainder, round round, second second, seconds seconds, succ succ, tdiv(other : Int) tdiv, times(&block : self -> ) : Nil
times times, to(to)
to(to, &block : self -> ) : Nil to, to_big_i : BigInt to_big_i, to_big_r to_big_r, to_io(io : IO, format : IO::ByteFormat) to_io, to_json(json : JSON::Builder) to_json, to_s(base : Int, upcase : Bool = false)
to_s(io : IO)
to_s(base : Int, io : IO, upcase : Bool = false)
to_s to_s, trunc trunc, upto(to)
upto(to, &block : self -> ) : Nil upto, week week, weeks weeks, year year, years years, ~ ~

### Class methods inherited from struct `Int`

from_io(io : IO, format : IO::ByteFormat) from_io

### Instance methods inherited from module `Comparable(BigRational)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigInt)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Number`

*(other : Complex)
*(other : BigFloat) *, +(other : BigFloat)
+(other : Complex)
+ +, -(other : Complex)
-(other : BigFloat) -, /(other : Complex) /, <=>(other : BigFloat)
<=>(other) <=>, ==(other : Complex) ==, abs abs, abs2 abs2, cis cis, clamp(min, max)
clamp(range : Range) clamp, divmod(number) divmod, i i, round(digits, base = 10) round, sign sign, significant(digits, base = 10) significant, step(*, to = nil, by = 1, &block)
step(*, to = nil, by = 1) step, to_big_f to_big_f, to_c to_c, to_yaml(yaml : YAML::Builder) to_yaml

### Class methods inherited from struct `Number`

zero : self zero

### Instance methods inherited from module `Comparable(BigFloat)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(Number)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Value`

==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try

### Class methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io) : self from_yaml

## Class Method Detail

def self.new(str : String, base = 10) #

Creates a `BigInt` with the value denoted by str in the given base.

Raises `ArgumentError` if the string doesn't denote a valid integer.

    BigInt.new("123456789123456789123456789123456789") # => 123456789123456789123456789123456789
    BigInt.new("1234567890ABCDEF", base: 16)           # => 1311768467294899695

def self.new(num : Int::Signed) #

Creates a `BigInt` from the given num.

def self.new(num : Int::Unsigned) #

Creates a `BigInt` from the given num.

def self.new(num : Float) #

Creates a `BigInt` from the given num.

def self.new(num : BigInt) #

Returns num. Useful for generic code that does `T.new(...)` with `T` being a `Number`.

def self.new #

Creates a `BigInt` with the value zero.

    require "big"
    BigInt.new # => 0

## Instance Method Detail

def %(other : Int) : BigInt #
def &(other : Int) : BigInt #
def *(other : BigInt) : BigInt #
def *(other : Int::Signed) : BigInt #
def *(other : Int::Unsigned) : BigInt #
def **(other : Int) : BigInt #
def +(other : BigInt) : BigInt #
def +(other : Int) : BigInt #
def -(other : BigInt) : BigInt #
def -(other : Int) : BigInt #
def - : BigInt #
def /(other : Int) : BigInt #
def <<(other : Int) : BigInt #
def <=>(other : BigInt) #
def <=>(other : Int::Signed) #
def <=>(other : Int::Unsigned) #
def <=>(other : Float) #
def >>(other : Int) : BigInt #
def ^(other : Int) : BigInt #
def abs : BigInt #
def clone #
def digits : Array(Int32) #
def gcd(other : BigInt) : BigInt #
def gcd(other : Int) : Int #
def hash #
def inspect #
def inspect(io) #
def lcm(other : BigInt) : BigInt #
def lcm(other : Int) : BigInt #
def popcount #
def remainder(other : Int) : BigInt #
def tdiv(other : Int) : BigInt #
def to_big_i #
def to_f #
def to_f32 #
def to_f64 #
def to_i #
def to_i16 #
def to_i32 #
def to_i64 #
def to_i8 #
def to_s(base : Int) #

Returns a string containing the representation of big radix base (2 through 36).

    BigInt.new("123456789101101987654321").to_s(8)  # => "32111154373025463465765261"
    BigInt.new("123456789101101987654321").to_s(16) # => "1a249b1f61599cd7eab1"
    BigInt.new("123456789101101987654321").to_s(36) # => "k3qmt029k48nmpd"

def to_s #

Returns a string representation of self.

    BigInt.new("123456789101101987654321").to_s # => 123456789101101987654321

def to_s(io) #

Returns a string representation of self.

    BigInt.new("123456789101101987654321").to_s # => 123456789101101987654321

def to_u #
def to_u16 #
def to_u32 #
def to_u64 #
def to_u8 #
def to_unsafe #
def unsafe_floored_div(other : Int) : BigInt #
def unsafe_floored_div(other : BigInt) : BigInt #
def unsafe_floored_mod(other : BigInt) : BigInt #
def unsafe_floored_mod(other : Int) : BigInt #
def unsafe_truncated_div(other : BigInt) : BigInt #
def unsafe_truncated_div(other : Int) : BigInt #
def unsafe_truncated_mod(other : BigInt) : BigInt #
def unsafe_truncated_mod(other : Int) : BigInt #
def |(other : Int) : BigInt #
def ~ : BigInt #